<?php
/**
 * Created by PhpStorm.
 * User: robin
 * Date: 9/27/15
 * Time: 1:51 AM
 */

namespace Luticate\Auth\Business;

use Luticate\Utils\Controller\LuticateApplication;

class JwtHelper
{
    const EXPIRATION_KEY =  "expiration_date";
    const SETTING_MCRYPT_KEY = "MCRYPT_KEY";
    const SETTING_JWT_KEY = "JWT_KEY";

    public static function decode($token)
    {
        $app = LuticateApplication::getInstance();
        try
        {
            $jwt = mcrypt_decrypt(MCRYPT_TRIPLEDES, $app->getSetting(self::SETTING_MCRYPT_KEY), base64_decode($token), "cbc");
            $data = (array)\JWT::decode($jwt, $app->getSetting(self::SETTING_JWT_KEY), ['HS256']);
        }
        catch (\Exception $e)
        {
            return null;
        }

        $expiration_date = array_key_exists(self::EXPIRATION_KEY, $data) ? $data[self::EXPIRATION_KEY] : null;
        if (!is_numeric($expiration_date) || $expiration_date < time()) {
            return null;
        }

        return $data;
    }

    public static function encode($data, $session_time)
    {
        $app = LuticateApplication::getInstance();
        $date = new \DateTime("now", new \DateTimeZone("Europe/Paris"));
        $date->modify("+${session_time} day");
        $data[self::EXPIRATION_KEY] = $date->getTimestamp();

        return base64_encode(mcrypt_encrypt(MCRYPT_TRIPLEDES, $app->getSetting(self::SETTING_MCRYPT_KEY),
            \JWT::encode($data, $app->getSetting(self::SETTING_JWT_KEY)), "cbc"));
    }
}