<?php
/**
 * Created by PhpStorm.
 * User: robin
 * Date: 7/2/16
 * Time: 9:45 PM
 */

namespace Luticate\Auth\Controller;

use Luticate\Auth\Business\LuUsersBusiness;
use Luticate\Auth\Dbo\LuUsersDbo;
use Luticate\Auth\Dbo\LuUsersLiteDbo;
use Luticate\Auth\Dbo\LuUsersLoginDbo;
use Luticate\Auth\Dbo\LuUsersLoginResultDbo;
use Luticate\Utils\Controller\LuController;
use Luticate\Utils\Dbo\LuQueryDbo;

class LuUsersController extends LuController
{
    public function getBusiness()
    {
        return new LuUsersBusiness();
    }

    /**
     * Login the user
     * @param $login LuUsersLoginDbo The user authentication data
     * @return LuUsersLoginResultDbo
     */
    public function login(LuUsersLoginDbo $login)
    {
        return static::getBusiness()->login($login);
    }

    /**
     * Logout the logged user
     * @param $_user LuUsersDbo The logged user
     * @return bool
     */
    public function logout(LuUsersDbo $_user)
    {
        return static::getBusiness()->logout($_user);
    }

    /**
     * Get all users
     * @param LuQueryDbo $query The filter query
     * @return LuUsersLiteDbo[]
     */
    public function getAllLite(LuQueryDbo $query)
    {
        return static::getBusiness()->getAllLite($query);
    }
}