<?php

namespace Luticate\Auth\DataAccess;

use Luticate\Auth\DataAccess\Sp\SpLuGetUserEffectivePermissionById;
use Luticate\Auth\DataAccess\Sp\SpLuGetUserEffectivePermissionByName;
use Luticate\Auth\DataAccess\Sp\SpLuGetUserEffectivePermissions;
use Luticate\Utils\DataAccess\LuDataAccess;

class LuPermissionsDataAccess extends LuDataAccess {
    protected static $_connection = "luticatedb";
    protected static $_table = "lu_permissions";

    public static function getUserEffectivePermissionById(int $userId, int $permissionId)
    {
        return SpLuGetUserEffectivePermissionById::getUserEffectivePermission($userId, $permissionId);
    }

    public static function getUserEffectivePermissionByName(int $userId, string $permissionName)
    {
        return SpLuGetUserEffectivePermissionByName::getUserEffectivePermission($userId, $permissionName);
    }

    public static function getUserEffectivePermissions(int $userId)
    {
        return SpLuGetUserEffectivePermissions::getUserEffectivePermissions($userId);
    }
}