<?php
/**
 * Created by PhpStorm.
 * User: robin
 * Date: 7/7/16
 * Time: 4:41 PM
 */

namespace Luticate\Auth\DataAccess;


use Illuminate\Database\Query\Builder;
use Luticate\Auth\Dbo\LuUsersDbo;
use Luticate\Utils\DataAccess\LuDataAccess;
use Luticate\Utils\Dbo\LuQueryDbo;

class LuUserDataAccess extends LuDataAccess
{
    protected static $_connection = "luticatedb";
    protected static $_table = "lu_users";
    protected static $_dboClass = LuUsersDbo::class;

    /**
     * @param $username
     * @return LuUsersDbo|null
     */
    public static function getByUsernameOrEmail($username)
    {
        return static::getSingle(function($q) use ($username)
        {
            /**
             * @var $q Builder
             */
            $q->where("username", "=", $username)->orWhere("email", "=", $username);
            return $q;
        });
    }

    public static function getAll(LuQueryDbo $query)
    {
        return static::getMultiplePaginated(function ($q) use($query)
        {
            /**
             * @var $q Builder
             */
            $q->whereRaw("sp_match_texts(:_query, username, email, firstname, lastname)");
            return $q;
        }, $query->getPage(), $query->getPerPage());
    }

}